<?php
$xoopsTpl = new XoopsTpl;

if ($op == 'add_ok') {
    if (!XoopsSingleTokenHandler::quickValidate('add_uitem')) redirect_header('admin.php?fct=uitems', 5, _INVALID_TICKET_MSG);

    // Check input values
    $errors = array();
    if (!isset($_POST['itemname']) || $_POST['itemname'] == '') {
        $errors[] = sprintf(_AM_REQ_MSG, _AM_ITEMNAME);
    } elseif (preg_match('/[^a-z]/', $_POST['itemname'])) {
        $errors[] = _AM_ALPH_ITEMNAME_MSG;
    }
    if (!isset($_POST['title']) || $_POST['title'] == '') $errors[] = sprintf(_AM_REQ_MSG, _AM_TITLE);
    if (!isset($_POST['itemtype']) || $_POST['itemtype'] == '') $errors[] = sprintf(_AM_REQ_MSG, _AM_ITEMTYPE);
    if ($_POST['itemtype'] == 'select' || $_POST['itemtype'] == 'radio' || $_POST['itemtype'] == 'check') {
        if (!isset($_POST['options']) || $_POST['options'] === '') {
            $errors[] = sprintf(_AM_REQ_MSG, _AM_OPTIONS);
        }
    } elseif ($_POST['options'] !== '') {
        $errors[] = sprintf(_AM_CANT_INPUT_OPTIONS_MSG);
    }
    if (!isset($_POST['regorder']) || $_POST['regorder'] === '' || !is_numeric($_POST['regorder']) || intval($_POST['regorder']) < 0) $errors[] = sprintf(_AM_OVERZERO_MSG, _AM_REGORDER);
    if (!isset($_POST['editorder']) || $_POST['editorder'] === '' || !is_numeric($_POST['editorder']) || intval($_POST['editorder']) < 0) $errors[] = sprintf(_AM_OVERZERO_MSG, _AM_EDITORDER);
    if (!isset($_POST['infoorder']) || $_POST['infoorder'] === '' || !is_numeric($_POST['infoorder']) || intval($_POST['infoorder']) < 0) $errors[] = sprintf(_AM_OVERZERO_MSG, _AM_INFOORDER);

    $regdefault = $_POST['itemtype'] == 'yesno' ? 0 : '';

    $res = $xoopsDB->query("SELECT * FROM `$uitems_tbl` WHERE `itemname` = '" . addslashes($_POST['itemname']) . "'");
    if ($xoopsDB->getRowsNum($res) > 0 || in_array($_POST['itemname'], $users_def_itemnames)) $errors[] = _AM_DUP_ITEMNAME_MSG;

    if (count($errors) == 0) {
        $sql = "INSERT INTO `$uitems_tbl` (`itemname`, `title`, `itemtype`, `candel`, `options`, `regdefault`, `required`, `regorder`, `editorder`, `infoorder`) VALUES('";
        $sql .= addslashes($_POST['itemname']) . "', '";
        $sql .= addslashes($_POST['title']) . "', '";
        $sql .= addslashes($_POST['itemtype']) . "', ";
        $sql .= "1, '";
        $sql .= addslashes($_POST['options']) . "', '";
        $sql .= $regdefault . "', ";
        $sql .= intval($_POST['required']) . ", ";
        $sql .= intval($_POST['regorder']) . ", ";
        $sql .= intval($_POST['editorder']) . ", ";
        $sql .= intval($_POST['infoorder']);
        $sql .= ")";
        if ($xoopsDB->query($sql)) {
            $sql = "ALTER TABLE `$users_tbl` ADD `" . addslashes($_POST['itemname']) . "` " . $table_datatypes[$_POST['itemtype']] . " NOT NULL";
            $itemid = $xoopsDB->getInsertId();
            if ($xoopsDB->query($sql)) {
                redirect_header("admin.php?fct=uitems&op=detail&itemid=$itemid", 5, sprintf(_AM_COMPLETE_MSG, $myts->htmlSpecialChars($_POST['itemname']), _ADD));
            } else {
                $xoopsDB->query("DELETE FROM `$uitems_tbl` WHERE `itemid` = " . $itemid);
            }
        }
        $errors[] = sprintf(_AM_FAILED_MSG, $myts->htmlSpecialChars($_POST['itemname']), _ADD);
    }
    $xoopsTpl->assign('itemname', $myts->htmlSpecialChars($_POST['itemname']));
    $xoopsTpl->assign('title', $myts->htmlSpecialChars($_POST['title']));
    $xoopsTpl->assign('itemtype', $myts->htmlSpecialChars($_POST['itemtype']));
    $xoopsTpl->assign('options', $myts->htmlSpecialChars($_POST['options']));
    $xoopsTpl->assign('required', $myts->htmlSpecialChars($_POST['required']));
    $xoopsTpl->assign('regorder', $myts->htmlSpecialChars($_POST['regorder']));
    $xoopsTpl->assign('editorder', $myts->htmlSpecialChars($_POST['editorder']));
    $xoopsTpl->assign('infoorder', $myts->htmlSpecialChars($_POST['infoorder']));
    $xoopsTpl->assign('errors', $errors);
}

xoops_cp_header();

$xoopsTpl->assign('itemtype_options', $datatypes);

$token = XoopsSingleTokenHandler::quickCreate('add_uitem');
$xoopsTpl->assign('token', $token->getHtml());

$xoopsTpl->display(XOOPS_ROOT_PATH . '/modules/system/admin/uitems/templates/uitems_add.html');
xoops_cp_footer();

?>